#include <string.h>

char *ExtractFileName(char *pszPathName)
{
   char *pszLastComponent = pszPathName, psz;

   for (psz = pszPathName; *psz != L'\0'; psz++)
   {
      if (*psz == L'\\' || *psz == L':')
         pszLastComponent = psz + 1;
   }

   return(pszLastComponent);
}

char MakeCompressedName(char *pszFileName)
{
    char chReplaced = '\0';
    size_t NameLength = strlen(pszFileName), DotIndex = NameLength;

    while ((DotIndex > 0) && (pszFileName[--DotIndex] != '.')) {
        if ((pszFileName[DotIndex] == '\\') ||
            (pszFileName[DotIndex] == ':')) {   // end of filename part of path
            DotIndex = 0;                       // name has no extension
            break;
        }
    }

    if (DotIndex > 0) {                         // name has an extension
        if ((NameLength - DotIndex ) <= 3) {    // extension less than 3 chars
            pszFileName[NameLength++] = '_';    // append '_' to extension
            pszFileName[NameLength++] = 0;      // terminate
        } else {                                // extension more than 3 chars
            chReplaced = pszFileName[NameLength - 1]; // return original
            pszFileName[NameLength - 1] = '_';  // replace last char with '_'
        }
    } else {                                    // name has no extension
        pszFileName[NameLength++] = '.';        // append '.'
        pszFileName[NameLength++] = '_';        // append '_'
        pszFileName[NameLength++] = 0;          // terminate
    }

    return(chReplaced);
}

